package com.wissamfawaz;

import java.nio.CharBuffer;

public class CharBufferDemo {

	public static void main(String[] args) {
		String str = "banana";
		
		CharBuffer buffer = CharBuffer.allocate(12);
		System.out.println("After creating buffer: ");
		System.out.println("Capacity: " + buffer.capacity());
		System.out.println("Position: " + buffer.position());
		System.out.println("Limit: " + buffer.limit());
		
		for(int i=0; i<str.length(); i++)
			buffer.put(str.charAt(i));
		
		buffer.flip();
		
		System.out.println("After flipping buffer: ");
		System.out.println("Position: " + buffer.position());
		System.out.println("Limit: " + buffer.limit());

		/*
		 * while(buffer.hasRemaining()) System.out.println(buffer.get() +
		 * ", remaining: " + buffer.remaining());
		 
		/*char[] chars = new char[buffer.length()];
		buffer.get(chars);
		System.out.println("Content of buffer: " + new String(chars));
		*/
		//System.out.println("Content of buffer: " + getContent(buffer));
		
		System.out.println(buffer.get());
		
		System.out.println("After reading first char from buffer: ");
		System.out.println("Position: " + buffer.position());
		System.out.println("Limit: " + buffer.limit());
		
		buffer.mark();
		
		System.out.println(buffer.get());
		System.out.println("After reading second char from buffer: ");
		System.out.println("Position: " + buffer.position());
		System.out.println("Limit: " + buffer.limit());

		buffer.reset();
		System.out.println("After resetting buffer: ");
		System.out.println("Position: " + buffer.position());
		System.out.println("Limit: " + buffer.limit());

		
		/*
		 * buffer.compact();
		 * 
		 * System.out.println("After compacting buffer: ");
		 * System.out.println("Position: " + buffer.position());
		 * System.out.println("Limit: " + buffer.limit());
		 */

		
		
		  buffer.clear(); 
		  System.out.println("After clearing buffer: ");
		  System.out.println("Position: " + buffer.position());
		  System.out.println("Limit: " + buffer.limit());
		 


	}
	
	private static String getContent(CharBuffer buffer) {
		char[] chars = buffer.array();
		String str = new String(chars);
		return str;
	}

}
